﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;
using Infragistics.Web.UI.Framework.Data;
using System.Data.SqlClient;

namespace WebApplication4
{
    public partial class WebForm2 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                DataSet ds = GetItemSearchResult(null, null, "156", "", "", "", "", "", "");
                BindResultGrid(ds);
            }
            else
            {
                if (Session["SearchResult"] != null)
                {
                    this.ResultGrid.GridView.ClearDataSource();
                    this.ResultGrid.DataSource = Session["SearchResult"] as DataSet;
                    this.ResultGrid.DataMember = "Projects";
                    this.ResultGrid.DataKeyFields = "ProjectSequence";
                    this.ResultGrid.DataBind();
                }
            }
        }

        public DataSet GetItemSearchResult(int? projectStatus, int? itemStatus, string dept, string merchColl, string itemClass, string style,
                               string prodType, string launchYear, string itemId)
        {
            SqlConnection cn = new SqlConnection("Data Source=PY1DBMAPD01;Initial Catalog=DMD_MGMT;Integrated Security=True");
            SqlCommand cmd = new SqlCommand();
            cmd.Connection = cn;
            cmd.CommandText = "NPP_GetItemSearchResult";
            cmd.CommandType = CommandType.StoredProcedure;
            cmd.Parameters.AddWithValue("@dept", dept);

            DataSet ds = new DataSet();

            SqlDataAdapter da = new SqlDataAdapter();
            da.SelectCommand = cmd;
            da.Fill(ds);

            ds.Tables[0].TableName = "Projects";
            ds.Tables[1].TableName = "AAItems";
            ds.Tables[2].TableName = "NPPItems";

            if (ds.Tables["Projects"].PrimaryKey.Length == 0)
            {
                //Set the table's primary key field
                ds.Tables["Projects"].PrimaryKey = new DataColumn[] { 
                    ds.Tables["Projects"].Columns["ProjectSequence"] };
            }

            if (ds.Tables["AAItems"].PrimaryKey.Length == 0)
            {
                //Set the table's primary key field
                ds.Tables["AAItems"].PrimaryKey = new DataColumn[] { 
                    ds.Tables["AAItems"].Columns["ItemID"] };
            }

            //}
            if (ds.Tables["NPPItems"].PrimaryKey.Length == 0)
            {
                //Set the table's primary key field
                ds.Tables["NPPItems"].PrimaryKey = new DataColumn[] { 
                    ds.Tables["NPPItems"].Columns["ENG_ITEM_ID"] };
            }

            //Set the relationship betw Projects-AAItems
            if (!(ds.Relations.Contains("Projects-AAItems")))
            {
                System.Data.DataRelation projRel = new System.Data.DataRelation("Projects-AAItems", ds.Tables["Projects"].Columns["ProjectSequence"], ds.Tables["AAItems"].Columns["ProjectSequence"]);
                ds.Relations.Add(projRel);
            }

            if (!(ds.Relations.Contains("AAItems-NPPItems")))
            {
                //Set the relationship betw AAItems-NPPItems
                System.Data.DataRelation itemRel = new System.Data.DataRelation("AAItems-NPPItems", ds.Tables["AAItems"].Columns["ITEMID"], ds.Tables["NPPItems"].Columns["Parent"]);
                ds.Relations.Add(itemRel);
            }

            Session["SearchResult"] = ds;

            return ds;
        }

        private void BindResultGrid(DataSet ds)
        {
            if (ds == null) return;

            if (ds.Tables.Count > 1) // AA Items are there in the result
            {
                //bool isEngItem = false;

                //if (ds.Tables["AAItems"].Rows.Count > 0)
                //{
                //    DataRow row = ds.Tables["AAItems"].Rows[0];
                //    string isEngItem1 = string.Empty;
                //    isEngItem1 = row["IsEngItem"].ToString();
                //    bool.TryParse(isEngItem1, out isEngItem);

                //}

                this.ResultGrid.GridView.ClearDataSource();
                ResultGrid.DataSource = ds;
                this.ResultGrid.DataMember = "Projects";
                this.ResultGrid.DataKeyFields = "ProjectSequence";
                ResultGrid.DataBind();

            }
        }

        protected void ResultGrid_OnRowExpanded(object sender, EventArgs e)
        {
        }
        protected void ResultGrid_RowIslandsPopulating(object sender, Infragistics.Web.UI.GridControls.ContainerRowCancelEventArgs e)
        {
        }
        protected void ResultGrid_OnInitializeBand(Object sender, BandEventArgs e)
        {
        }

        protected void ResultGrid_InitializeRow(Object sender, RowEventArgs e)
        {

            if (e.Row == null) return;

            ((ContainerGridRecord)e.Row).Expanded = true;
        }
    }
}
